/* linklist.c */
LinkList *create_link_list(void);
void initialize_link_list(LinkList *list);
Link *create_link_entry(void *data);
int add_link_to_head(LinkList *list, Link *entry);
int add_link_to_tail(LinkList *list, Link *entry);
void process_link_list(LinkList *list, void (*process_function)(LinkList *list, Link *ent));
void free_link(Link *link);
int remove_link(LinkList *list, Link *link);
void *delete_link(LinkList *list, Link *link);
Link *find_link_entry(LinkList *list, void *key, int (*find_function)(Link *link, void *key));
Link *find_next_link_entry(LinkList *list, Link *link, void *key, int (*find_function)(Link *link, void *key));
int move_link_up(LinkList *list, Link *link);
int move_link_down(LinkList *list, Link *link);
int add_link_before_link(LinkList *list, Link *new, Link *exist);
int add_link_after_link(LinkList *list, Link *new, Link *exist);
int set_current_link(LinkList *list, Link *link);
int set_head_current_link(LinkList *list);
int set_tail_current_link(LinkList *list);
int add_link_before_current(LinkList *list, Link *link);
int add_link_after_current(LinkList *list, Link *link);
int move_current_link_up(LinkList *list);
int move_current_link_down(LinkList *list);
int set_current_link_next(LinkList *list);
int cycle_current_link_next(LinkList *list);
int set_current_link_prev(LinkList *list);
int cycle_current_link_prev(LinkList *list);
int list_is_empty(LinkList *list);
int list_is_single_link(LinkList *list);
int link_is_current(LinkList *list, Link *link);
int link_is_head(LinkList *list, Link *link);
int link_is_tail(LinkList *list, Link *link);
int current_is_head(LinkList *list);
int head_is_current(LinkList *list);
int current_is_tail(LinkList *list);
int tail_is_current(LinkList *list);
int add_new_current_link_before(LinkList *list, Link *link);
int add_new_current_link_after(LinkList *list, Link *link);
void *get_data_from_link(Link *link);
void *get_data_from_current(LinkList *list);
void *get_data_from_head(LinkList *list);
void *get_data_from_tail(LinkList *list);
Link *get_head_link(LinkList *list);
Link *get_tail_link(LinkList *list);
Link *get_current_link(LinkList *list);
Link *get_next_link(Link *link);
Link *get_prev_link(Link *link);
